﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------
	
-------------------------------------------------------------------------------
-- you can customize your nUI scaling by either changing the scale values in
-- this table or adding new resolutions with their own scales. If you find that
-- a scale I have defined does not work, or you have a resolution that is not
-- in this table, please leave me a message at wowui.worldofwar.net or at
-- www.curse.com and let me know what values you are using so I can update the
-- table.

nUI_Scale =
{
	[800] =
	{
		[600] = 1.278,		-- 800x600
	},
	[1024] =
	{
		[768] = 1.002,		-- 1024x768
	},
	[1280] =
	{
		[720] = 1.07,		-- 1280x720
		[800] = 0.96,		-- 1280x800
		[1024] = 0.75,		-- 1280x1024
	},
	[1440] =
	{
		[900] = 0.855,		-- 1440x900
	},
	[1600] =
	{
		[1200] = 0.64,		-- 1600x1200
	},
	[1680] =
	{
		[1050] = 0.733,		-- 1680x1050
	},
	[1920] =
	{
		[1080] = 0.712,		-- 1920x1080
		[1200] = 0.64,		-- 1920x1200
	},
};

-------------------------------------------------------------------------------

function nUI:setScale()

	local screen_res    =({GetScreenResolutions()})[GetCurrentResolution()];
	local width, height = strmatch( screen_res, "(%d+)x(%d+)" );

	nUI.disp_width  = math.floor( width );
	nUI.disp_height = math.floor( height );
	nUI.scalar      = nUI.disp_width / 2560;

	if nUI_Config.scale then
		nUI.scale = nUI_Config.scale;
	elseif nUI_Scale[nUI.disp_width] and nUI_Scale[nUI.disp_width][nUI.disp_height] then
		nUI.scale = nUI_Scale[nUI.disp_width][nUI.disp_height];
	else
		nUI.scale = 0.65;
		nUI:debugMsg( 0, "no defined scale for ("..nUI.disp_width.."x"..nUI.disp_height..") resolution\nTry using '/nui scale' {n} to adjust your scale\nValues of {n} are usually between 0.62 and 1.2\nAdjust {n} until the dashboard fits your screen\nLet me know your resolution and scale when you get it\nso I can add it to my table. kscottpiel@gmail.com" );
	end

	nUI.scale = nUI.scalar * nUI.scale;
	nUI_MasterFrame:SetScale( nUI.scale );
	nUI_Console:SetScale( 0.8 );
end
